// Calculator.cpp : Implementation of CCalculator
#include "stdafx.h"
#include "TvC6Sample1.h"
#include "Calculator.h"

/////////////////////////////////////////////////////////////////////////////
// CCalculator


long CCalculator::m_DigitReceived(BSTR *Digit)
{
	wstring mDigit = *Digit;


    switch (CalculatorState)
	{

		case csWelcome:
		case csFirstOperand:
			switch (*mDigit.c_str())
			{
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
						FirstOperand = FirstOperand + mDigit;
						CalculatorState = csFirstOperand;
						myCallController->StopPlayRecord();
					break;
				case '*':
					if (FirstOperand.length == 0) 
					{
						//At least one digit is needed for first operand
						myCallController->StopPlayRecord();
						CalculatorState = csError;
					}
					else
					{
						//Now wait for input of second operand
						CalculatorState = csSecondOperand;
					}
					break;
				default:
					//A wrong digit was entered
					CalculatorState = csError;
					myCallController->StopPlayRecord();
					break;
			}
			break;
		case csSecondOperand:
			switch (*mDigit.c_str())
			{
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
					SecondOperand = SecondOperand + mDigit;
					break;
				case '#':
					if (SecondOperand.length == 0) 
					{
						//At least one digit is needed for second operand
						myCallController->StopPlayRecord();
						CalculatorState = csError;
					}
					else
					{
						//Now calculate and output result
						CalculatorState = csResult;
					}
					break;
				default:
					//A wrong digit was entered
					CalculatorState = csError;
					myCallController->StopPlayRecord();
			}
			break;
	}

	
	return S_OK;

}

long CCalculator::m_Init(_CallController **objCallController)
{

	myCallController = *objCallController;
	
	myCallController->AddRef();

	return S_OK;

}

long CCalculator::m_UnInit()
{

	
	myCallController->Release();

	myCallController = NULL;
	
	return S_OK;

}

long CCalculator::m_PlayDone()
{

    switch (CalculatorState)
	{
    case csWelcome:
        CalculatorState = csFirstOperand;
        break;
    case csResult:
        CalculatorState = csWelcome;
        break;
    case csError:
        CalculatorState = csWelcome;
        break;
    }

	return S_OK;

}

long CCalculator::m_TimePulse()
{

	wstring Result = L"";
	wstring FileName;
	BSTR FileNameBSTR;
	BSTR ErrDescBSTR;
	VARIANT_BOOL IsPlaying;
	VARIANT_BOOL success = false;
	VARIANT_BOOL IsError = false;
	VARIANT varresult;
	long ErrNumber;
    long FirstOperandVal;
    long SecondOperandVal;
	HRESULT hr;

	if (myCallController == NULL) return S_OK;
	hr = myCallController->get_IsPlaying(&IsPlaying);

	//IsPlaying = *pIsPlaying;

	long i;

    switch (CalculatorState) 
	{
    case csWelcome:
        if (!IsPlaying) 
		{
			FileName = BasePath;
			FileName = FileName.append(L"\\Welcome.wav");
			FileNameBSTR = ::SysAllocString(FileName.c_str());
			myCallController->PlayAudioFile(&FileNameBSTR, &success);
            if (!success) 
			{
				ErrNumber = 10;
				ErrDescBSTR = ::SysAllocString(L"Unable to play audio file");
				IsError = true;
                myCallController->WriteLogFile(&ErrNumber, &ErrDescBSTR, &IsError, &varresult);
                myCallController->HangUp();
            }
        }
        break;
    case csResult:
        if (!IsPlaying) 
		{ 
			wistringstream is1(FirstOperand);
			is1 >> FirstOperandVal;
			wistringstream is2(SecondOperand);
			is2 >> SecondOperandVal;
			
            FirstOperandVal = FirstOperandVal + SecondOperandVal;

			wchar_t Buffer[20];

			_ltow(FirstOperandVal,Buffer,10);

            Result = Buffer;

            FirstOperand = L"";
            SecondOperand = L"";


			SAFEARRAYBOUND sabound[1];  
			SAFEARRAY FAR* psa = NULL;
			BSTR bstr = NULL; 

			// Create an array of size Result.length
			sabound[0].cElements = (long)(Result.length()) + 1;
			sabound[0].lLbound = 0;    
			psa = SafeArrayCreate(VT_BSTR, 1, sabound);
			if (psa == NULL)
				return ResultFromScode(E_OUTOFMEMORY);

			FileName = BasePath;
			FileName = FileName.append(L"\\TheResultIs.wav");
			bstr = SysAllocString(FileName.c_str()); 
			OutputDebugStringW(bstr);
			i = 0;
			hr = SafeArrayPutElement(psa, &i, bstr);
			SysFreeString(bstr);   
			if (FAILED(hr))
				goto error;

			for (long i=1; i<= Result.length(); i++)
			{
				FileName = BasePath;
				FileName = FileName.append(L"\\");
				FileName = FileName.append(Result.substr(i-1,1));
				FileName = FileName.append(L"A.wav");
				bstr = SysAllocString(FileName.c_str()); 
				OutputDebugStringW(bstr);
				hr = SafeArrayPutElement(psa, &i, bstr);
				SysFreeString(bstr);   
				if (FAILED(hr))
					goto error;
			}  
			
			myCallController->PlayAudioFileList(&psa,&success);

            if (!(success)) 
			{
				ErrNumber = 12;
				ErrDescBSTR = ::SysAllocString(L"Unable to play audio file list");
				IsError = true;
                myCallController->WriteLogFile(&ErrNumber, &ErrDescBSTR, &IsError, &varresult);
                myCallController->HangUp();
            }
        }
        break;
    case csError:
        if (!IsPlaying) 
		{
			FileName = BasePath;
			FileName = FileName.append(L"\\Error.wav");
			FileNameBSTR = ::SysAllocString(FileName.c_str());
			myCallController->PlayAudioFile(&FileNameBSTR, &success);
            if (!success) 
			{
				ErrNumber = 14;
				ErrDescBSTR = ::SysAllocString(L"Unable to play audio file");
				IsError = true;
                myCallController->WriteLogFile(&ErrNumber, &ErrDescBSTR, &IsError, &varresult);
                myCallController->HangUp();
            }
        }
    }

	return S_OK;

	error:
		return hr;
}
